//+------------------------------------------------------------------+
//|       Experimental Expert Advisor "Chuvashov's Fork"  Vilka_Ch_ExpertH1_v2.mq4 |
//|         for opening BUY and SELL positions             2010,author,Gkov |
//|     and drawing StopLoss in 3 stages            genkov@bk.ru |
//+------------------------------------------------------------------+
#property copyright "2010,author,Gkov"
#property link      "http://ForexkovTrade.com"
#property link      "http://Fxkom.narod.ru"
#property link      "http://forexparter.ucoz.ru/"
#property link      "http://Animatyc.narod.ru"                 
#property link      "genkov@bk.ru , kovgd@ya.ru"
//+------------------------------------------------------------------+
extern int N=50;           // number of calculated bars (for H1 N=50).
extern int M= 3;           // initial bar starting with which the fractals are searched in the loop.
int    i,k;                // bar numbers in loops.
int    Vnf3,Vnf2,Vnf1;     // numbers of reference fractals (1st on the right of the downtrend chart).
int    VnfL3,VnfL2,VnfL1;  // numbers of reference fractals (1st on the right of the uptrend chart).
int    VFN,VFNL;           // counter of the found fractals.
int    Md,MdL;             // counters of the number of modifications
double VMF1,VMF2,VMF3;     // intermediate values of the upper fractals on the downtrend.
double VMFL1,VMFL2,VMFL3;  // intermediate values of the lower fractals on the uptrend.
double VlFl_L;             // Min value of the nearest lower fractal on the downtrend
double VlFl_H;             // Max value of the nearest upper fractal on the uptrend
datetime tim1_L;           // Time of the nearest lower fractal following the downtrend 
datetime timL1_H;          // Time of the nearest upper fractal following the uptrend 
datetime tim1,tim2,tim3;   // time for drawing the Chuvashov's Fork lines.
datetime timL1,timL2,timL3;// time for drawing the Chuvashov's Fork lines.
string   Time1,Time2,Time3;   // time for visual control of operators' performance.
string   TimeL1,TimeL2,TimeL3;// time for visual control of operators' performance.
       // for trend lines directed downwards 
double V_down1,            // speeds of falling of the MAIN(1) trend line over 1 bar.
       V_down2,            // speeds of falling of the lateral trend line over 1 bar.
       PricePrL1_1f,       // Price of the projection of the MAIN(1) trend line on the 1st fractal.
       PricePrL1_2f,       // Price of the projection of the MAIN(1) trend line on the 2nd fractal.
       PricePrL1_1b,       // Price of the projection of the MAIN(1) trend line on the 1st current BAR.
       PricePrL2_1f,       // Price of the projection of the Lateral(2) trend line on the 1st fractal.
       PricePrL2_1b,       // Price of the projection of the Lateral(2) trend line on the 1st current BAR.
       TP_Modific_S;
       // for trend lines directed upwards
double V_up1,              // speeds of falling of the MAIN(1) trend line over 1 bar.
       V_up2,              // speeds of falling of the lateral trend line over 1 bar.
       PricePrH1_1f,       // Price of the projection of the MAIN(1) trend line on the 1st fractal.
       PricePrH1_2f,       // Price of the projection of the MAIN(1) trend line on the 2nd fractal.
       PricePrH1_1b,       // Price of the projection of the MAIN(1) trend line on the 1st current BAR.
       PricePrH2_1f,       // Price of the projection of the Lateral(2) trend line on the 1st fractal.
       PricePrH2_1b,       // Price of the projection of the Lateral(2) trend line on the 1st current BAR.
       TP_Modific_B;

extern double Lots=1.0;
extern double SL_B=30;     // StopLoss is calculated upon placing of every given order.
extern double TP_B=35;     // it is advisable to calculate TP_B based on 0.6 of the channel size.
extern double SL_S=30;     // StopLoss is calculated upon placing of every given order.
extern double TP_S=35;     // it is advisable to calculate TP_B based on 0.6 of the channel size.
int Magic;
bool  patternBuy  = false; // values: true "1" or false "0".
bool  patternSell = false; // values: true "1" or false "0".
 //+------------------------------------------------------------------+
  void DelLine()        // Deleting the Sell trend lines and Chuvashov's Fork marks 
   {
   ObjectDelete("Tr_down1");
   ObjectDelete("Tr_down2");
   ObjectDelete("Frak_1");
   ObjectDelete("Frak_2");
   ObjectDelete("Frak_3");
   }
//+------------------------------------------------------------------+
  void DelLineH()        // Deleting the BUY trend lines and Chuvashov's Fork marks 
   {
   ObjectDelete("Tr_up1");
   ObjectDelete("Tr_up2");
   ObjectDelete("Fr_1");
   ObjectDelete("Fr_2");
   ObjectDelete("Fr_3");
   }
//+------------------------------------------------------------------+
  void CreateLine()       // Creating and drawing the Sell trend lines of Chuvashov's Fork 
   {
   ObjectCreate("Tr_down1",OBJ_TREND,0,tim3,VMF3,tim2,VMF2);
   ObjectSet("Tr_down1",OBJPROP_COLOR,Yellow);
   ObjectSet("Tr_down1",OBJPROP_WIDTH,1);  // in a thin line and 
   ObjectSet("Tr_down1",OBJPROP_STYLE,STYLE_DOT);// dotted line
   ObjectCreate("Tr_down2",OBJ_TREND,0,tim2,VMF2,tim1,VMF1);
   ObjectSet("Tr_down2",OBJPROP_COLOR,Aqua);
   ObjectSet("Tr_down2",OBJPROP_WIDTH,1);  // in a thin line and 
   ObjectSet("Tr_down2",OBJPROP_STYLE,STYLE_DOT);// dotted line 
   }
//+------------------------------------------------------------------+
  void CreateLineH()       // Creating and drawing the BUY trend lines of Chuvashov's Fork 
   {
   ObjectCreate("Tr_up1",OBJ_TREND,0,timL3,VMFL3,timL2,VMFL2);
   ObjectSet("Tr_up1",OBJPROP_COLOR,Yellow);
   ObjectSet("Tr_up1",OBJPROP_WIDTH,1);  // in a thin line and 
   ObjectSet("Tr_up1",OBJPROP_STYLE,STYLE_DOT);// dotted line
   ObjectCreate("Tr_up2",OBJ_TREND,0,timL2,VMFL2,timL1,VMFL1);
   ObjectSet("Tr_up2",OBJPROP_COLOR,Aqua);
   ObjectSet("Tr_up2",OBJPROP_WIDTH,1);  // in a thin line and 
   ObjectSet("Tr_up2",OBJPROP_STYLE,STYLE_DOT);// dotted line 
   }
//+------------------------------------------------------------------+
   void CreateArrow()   // Creating and drawing marks for the Sell trend lines of Chuvashov's Fork
    {
    ObjectCreate("Frak_1",OBJ_ARROW, 0, tim1, VMF1+0.001);
    ObjectSet("Frak_1", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Frak_1", OBJPROP_ARROWCODE,217); //217-fractal mark code
    ObjectCreate("Frak_2",OBJ_ARROW, 0, tim2, VMF2+0.001);
    ObjectSet("Frak_2", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Frak_2", OBJPROP_ARROWCODE,217); //217-fractal mark code
    ObjectCreate("Frak_3",OBJ_ARROW, 0, tim3, VMF3+0.001);
    ObjectSet("Frak_3", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Frak_3", OBJPROP_ARROWCODE,217); //217-fractal mark code
    }
//+------------------------------------------------------------------+
   void CreateArrowH()   // Creating and drawing marks for the BUY trend lines of Chuvashov's Fork
    {
    ObjectCreate("Fr_1",OBJ_ARROW, 0, timL1, VMFL1-0.0001);
    ObjectSet("Fr_1", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Fr_1", OBJPROP_ARROWCODE,218); //218-fractal mark code
    ObjectCreate("Fr_2",OBJ_ARROW, 0, timL2, VMFL2-0.0001);
    ObjectSet("Fr_2", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Fr_2", OBJPROP_ARROWCODE,218); //218-fractal mark code
    ObjectCreate("Fr_3",OBJ_ARROW, 0, timL3, VMFL3-0.0001);
    ObjectSet("Fr_3", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Fr_3", OBJPROP_ARROWCODE,218); //218-fractal mark code
    }
//+------------------------------------------------------------------+
 void Op_Buy_Ch()                                  // opening a BUY position
  {
  if(!OrderSend(Symbol(),OP_BUY,Lots,Ask,2,Bid-SL_B*Point,Ask+TP_B*Point," ",Magic,0,DeepSkyBlue))
      { Print("  SELL order opening error  # ",GetLastError()); }
      return(0);
     }
//+------------------------------------------------------------------+
 void Op_Sell_Ch()
  { 
  if(!OrderSend(Symbol(),OP_SELL,Lots,Bid,2,Ask+SL_S*Point,Bid-TP_S*Point," ",Magic,0,Red)) 
      { Print("  SELL order opening error  # ",GetLastError()); }
      return(0);
     }
//+------------------------------------------------------------------+
 void Close_B_Ch()
  {
  if(!OrderClose(OrderTicket(),OrderLots(),Bid,2,Aqua)) // closing 0.1 lot 
      {Print(" Closing order # ",OrderTicket()," Error # ",GetLastError());}
       return(0);
     }
//+------------------------------------------------------------------+
 void Close_S_Ch()
  {
  if(!OrderClose(OrderTicket(),OrderLots(),Ask,2,Aqua)) // closing 0.1 lot 
      {Print(" Closing order # ",OrderTicket()," Error # ",GetLastError());}
      return(0);
     }  
//+==================================================================+
//|   expert start function                                          +
//+------------------------------------------------------------------+
int start()
  {//start
   if(Volume[0]>1) return; //starting to trade at the first tick of the new bar.
    { //Vol-at the first tick  
    int spread=MarketInfo(Symbol(),MODE_SPREAD);
    int StopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
    double Ma144_1 = iMA(NULL,0,144,0,MODE_EMA,PRICE_CLOSE,1);
    double Ma144_24 = iMA(NULL,0,144,0,MODE_EMA,PRICE_CLOSE,24);
    double Ma144_48 = iMA(NULL,0,144,0,MODE_EMA,PRICE_CLOSE,48);
    double Med48=(Ma144_1-Ma144_48)/2+Ma144_48; // projection of the middle of the interval from 1 to 48 bar
    // zeroing out the variables for the search of fractals at every tick.
    VFNL=0;VMFL3=0;VMFL2=0;VMFL1=0;VFN=0;VMF3=0;VMF2=0;VMF1=0;Md=0;MdL=0;
    tim1=0;tim2=0;tim3=0;timL1=0;timL2=0;timL3=0;patternBuy=false;patternSell=false;

// ==================================================================+
// ==================================================================+===== for a position BUY ==
// Loop for searching for the last three consecutive fractals    +
// lying along the DOWNtrend for the Chuvashov's Fork construction        +
// ==================================================================+
   for (i=M;i<=N;i++)
    {//loop
    if(High[i]>High[i+1] && High[i]>High[i+2] && High[i]>High[i-1] && High[i]>High[i-2])
     {//fractal
      VFN++;           // counter of the found fractal.
      // ------------------------------------------------------------+
      if(VFN==1)       // if the 1st fractal is found, store the following values: Max[i], candlestick no.[i], time[i]:
	   {// f1
	   Vnf1=i;        // store the Max bar number of the found fractal.
      VMF1=High[i];  // store the Max value of the 1st found fractal.
      tim1=iTime(NULL,0,i);        // store the time of the 1st reference point.
      }//-f1
    // --------------------------------------------------------------+
    if(VFN==2)        // if the 2nd fractal is found, store the following values: Max[i], candlestick no.[i], time[i]:
	  {// f2
     VMF2=High[i];    // store the Max value of the 2nd found fractal.
    if(VMF2>VMF1)       // if the Max value of the 2nd fractal is higher than that of the 1st fractal (i.e. directed downwards),
     {
     Vnf2=i;          // store the Max bar number of the found fractal.
     tim2=iTime(NULL,0,i);      // store the time of the 2nd reference point.
     }
     }//-f2
    // --------------------------------------------------------------+
    if(VFN==3)       // if the 3rd fractal is found, store the following values: Max[i], candlestick no.[i], time[i]:
     {//f3
     VMF3=High[i];    // store the Max value of the 3rd found fractal.
    if(VMF3>VMF2)       // if the Max value of the 3rd fractal is higher than that of the 2nd fractal,
     {
     Vnf3=i;          // store the Max bar number of the 3rd fractal.
     tim3=iTime(NULL,0,i);// store the time of the 3rd reference point.
     }
     }//-f3
// ------------------------------------------------------------------+
   if(VFN==3) break; // all three fractals are found, exit the loop.
// ------------------------------------------------------------------+ 
    }//-fractal                      
   }//-loop ========= the loop ends here!
// ------------------------------------------------------------------+
   if(VMF3>VMF2 && VMF2>VMF1)
    {  
    // Let us define whether the lateral(2) trend line is HIGHER than the projection of the MAIN(1)
    // trend line? For this purpose, we calculate the price value of the projection of the MAIN(1) trend line
    // on the vertical of the Max value of the 1st fractal:
    V_down1=((VMF3-VMF2)/(Vnf3-Vnf2));    // speeds of falling of the MAIN(1) trend line over 1 bar.
    PricePrL1_1f=VMF2-(Vnf2-Vnf1)*V_down1;  // price of the projection of the MAIN(1) trend line on the vertical of the 1st fractal.
    // now we compare the price value of the 1st fractal with the price of the projection of the MAIN(1) trend line
    // on the vertical of the Max value of the 1st fractal, and if the Max price of the 1st fractal is Higher than the price of the projection
    // of the MAIN(1) trend line on the same fractal, then the Chuvashov's Fork construction requirements are met.     
    if(VMF1>PricePrL1_1f) // if the pattern for opening a Buy position has emerged
     { 
     // considering that the values of the 1st fractal of the lateral line and the price of the 2nd fractal of the Main line
     // may turn out to be on the same level, let us check:
     if(VMF1==VMF2)  V_down2=0; // lateral line is horizontal
     if(VMF1<VMF2)
      { 
      V_down2=((VMF2-VMF1)/(Vnf2-Vnf1));  // speeds of falling of the lateral trend line over 1 bar.
      }   
     PricePrL2_1b=VMF1-Vnf1*V_down2; // price of the projection of the Lateral(2) trend line on the current 1st BAR.
     PricePrL1_1b=VMF2-Vnf1*V_down1; // price of the projection of the MAIN(1) trend line on the current 1st BAR
     // keep in mind that the pattern for opening a Buy position has emerged
     patternBuy = true; //patternSell = false; // pattern for opening a Buy position has emerged
     // draw marks and lines of the "Chuvashov's Fork" pattern
     DelLine(); CreateLine(); CreateArrow(); // draw marks and lines having deleted the preceding ones 
     }
    }
// ==================================================================+    
//                    Opening BUY positions                           +
// ==================================================================+
   if(OrdersTotal()<1) // we place one (or 2..3..etc.) orders  
    {  //open a position
// ------------------------------------------------------------------+
   if(patternBuy==true)
    { //patternBuy
     // 1st additional condition - price range over the last 25 bars is at least 50 points.
    if((High[iHighest(Symbol(),Period(),MODE_HIGH,25,0)]-Low[iLowest(Symbol(),Period(),MODE_LOW,25,0)])>=50*Point)
     {// price range
     // 2nd additional condition e.g. if the price is lower than 89 pip below the level of Ma144 (MA of 12 squared) 
    if(Bid<Ma144_1-89*Point &&       // the price is lower than Ma89s   
       (Ma144_1-Ma144_48)<0)         // Ma144 slope is negative
     {//2nd additional condition 
    if((High[1]>PricePrL2_1b ||                   // Max of the candlestick is higher than the lateral projection of the 1st Bar
       Close[1]>PricePrL2_1b ||                    // any candlestick closed above the projection of the 1st Bar
       (Open[1]<Close[1] && Close[1]>PricePrL2_1b) ||  // white candlestick crossed the projection of the 1st Bar
       Bid>PricePrL2_1b) && Bid<PricePrL2_1b+3*Point)   // not higher than 3 pip of the price of the projection of the 1st Bar
     {// opening a Buy position.
      // Calculate StopLoss as the Min price value over the interval from the "0" bar to the bar of the 2nd fractal.
      SL_B=(Bid-Low[iLowest(Symbol(),Period(),MODE_LOW,Vnf2,0)])/Point;
     if(SL_B<StopLevel) SL_B=StopLevel+12; // if SL_B is less than StopLevel
      //  SL_B=200;
      TP_B=120;
      Print("  OP_BUY Chuvashov's Fork","  VMF1 = ",VMF1," < ",PricePrH1_1f);
      Op_Buy_Ch();
      return;
      }//- opening a Buy position.
     }//-2nd additional condition.
    }//-price range
   }//-patternBuy
  }//-open a position
// ==================================================================+  
// ==================================================================+===== for a position SELL ==
// Loop for searching for the last three consecutive fractals    +
// lying along the UPtrend for the Chuvashov's Fork construction        +
// ==================================================================+      
// ==================================================================+
// Loop for searching for the last three lower fractals of the BUY trend for the Chuvashov's fork construction
   for (i=M;i<=N;i++)
    {//loop
    if(Low[i]<Low[i+1] && Low[i]<Low[i+2] && Low[i]<Low[i-1] && Low[i]<Low[i-2])
     {//fractal
      VFNL++;   // counter of the found fractal is increased by 1 if the condition is met.
   // ---------------------------------------------------------------+
    if(VFNL==1) // if the 1st fractal is found, store the following values: Low[i], candlestick no.[i], time[i]:
	   {// f1
       VMFL1=Low[i];             // Min value of the 1st found fractal.
       VnfL1=i;                  // Min bar number of the found fractal.
       timL1=iTime(NULL,0,i);    // time of the 1st found fractal.
      }//-f1
      // ------------------------------------------------------------+
    if(VFNL==2) // if the 2nd fractal is found, store the following values: Low[i], candlestick no.[i], time[i]:
	  {// f2
      VMFL2=Low[i];    // Min value of the 2nd found fractal.
      // according to the Chuvashov's Fork conditions, the Min of the 2nd fractal shall be lower than the Min of the 1st fractal
      if(VMFL2<VMFL1)             // and if the Min value of the 2nd fractal is lower than the Min of the 1st fractal,
      {//(f2<f1)
       VnfL2=i;                   // store the Min bar number of the found fractal.
       timL2=iTime(NULL,0,i);     // time of the 2nd found fractal.
      }//-(f2<f1)
     }//-f2
      // ------------------------------------------------------------+
    if(VFNL==3) // if the 3rd fractal is found, store the following values: Low[i], candlestick no.[i], time[i]:
     {//f3
      VMFL3=Low[i];    // Min value of the 3rd found fractal.
      // according to the Chuvashov's Fork conditions the Min of the 3rd fractal shall be lower than the Min of the 2nd fractal
      if(VMFL3<VMFL2)             // and if the Min value of the 3rd fractal is lower than the Min of the 2nd fractal,
       {//(f3<f2)
        VnfL3=i;                  // Min bar number of the 3rd fractal.
        timL3=iTime(NULL,0,i);    // time of the 3rd found fractal.
       }//-(f3<f2)
      }//-f3
     // -------------------------------------------------------------+
     if(VFNL==3) break; // all three fractals are found, exit the loop.
     // -------------------------------------------------------------+
    }//-fractal
   }//-loop ========= the loop ends here!
// ==================================================================*
  if(VMFL3<VMFL2 && VMFL2<VMFL1) // if the both trend lines are going UPWARDS - 
   {//the condition regarding the same direction of the both trend lines is met.
   // ---------------------------------------------------------------+
   // Let us define whether the lateral(2) trend line is LOWER than the projection of the MAIN(1) 
   // trend line? For this purpose, we calculate the price value of the projection of the MAIN(1) trend line
   // on the vertical of the Max value of the 1st fractal:
   V_up1=(VMFL2-VMFL3)/(VnfL3-VnfL2);  // speeds of the rise of the main trend line over 1 bar.
   PricePrH1_1f=VMFL3+(VnfL3-VnfL1)*V_up1; // price of the projection of the MAIN(1) trend line on the vertical of the 1st fractal.
   // now we compare the price value of the 1st fractal with the price of the projection of the MAIN(1) trend line 
   // on the vertical of the Min value of the 1st fractal, and if the Min price of the 1st fractal is lower than the price of the projection
   // of the MAIN(1) trend line on the same fractal, then the Chuvashov's Fork construction requirements are met.   
   if(VMFL1<=PricePrH1_1f) // if the price is lower (or on the same line!) - then the Chuvashov's Fork construction requirements are met. 
    {//the lateral(2) line is LOWER than the projection of the MAIN(1)
    // if the prices of the 1st and 2nd fractals coincided - the line is horizontal
    if(VMFL1==VMFL2) V_up2=0; // i.e. the speed of falling of the lateral(2) line =0
    if(VMFL1>VMFL2)  // fractal 1 is higher than fractal 2
     {// fractal 1 is higher than fractal 2 on the vertical of the 1st fractal
     V_up2=(VMFL1-VMFL2)/(VnfL2-VnfL1); // speed of falling of the lateral(2) trend line over 1 bar.
     }//- fractal 1 is higher than fractal 2
     PricePrH2_1b=VMFL1+(VnfL1-1)*V_up2; // price of the projection of the lateral(2) trend line on the 1st current Bar.
     // keep in mind that the pattern for opening a Buy position has emerged
     patternSell = true; //patternBuy = false; // pattern for opening a Sell position has emerged
     // draw marks and lines of the "Chuvashov's Fork" pattern
     DelLineH(); CreateLineH(); CreateArrowH(); // draw marks and lines having deleted the preceding ones 
    }//-the lateral(2) line is LOWER than the projection of the MAIN(1) on the vertical of the 1st fractal
// ------------------------------------------------------------------+
// Let us define the conditions for placing a SELL order, the price and StopLoss level:
// ------------------------------------------------------------------+
   if(patternSell == true)
    { //patternSell
    // 1st additional condition - price range over the last 25 bars is at least 50 points.
    if((High[iHighest(Symbol(),Period(),MODE_HIGH,25,0)]-Low[iLowest(Symbol(),Period(),MODE_LOW,25,0)])>=50*Point)
     {// price range
     // 2nd additional condition - if the price is higher than 34 pip of the Ma144 level (MA of 12 squared) 
     if((Bid>Ma144_1+55*Point &&                                               // price is higher than Ma55b 
       (Ma144_1-Ma144_48)>-5*Point &&                                          // positive direction
       Med48<Ma144_24))            // projection of the middle of the interval is lower than the actual value of Ma144 on bar 24
      {// Ma144
    // define the condition for opening a position BUY => the price shall cross the lateral trend line downward
    if(Open[1]>Close[1] && Close[1]<PricePrH2_1b ||  // if the black candlestick closed below the lateral line
      Close[1]<PricePrH2_1b ||   // or if the closing of the 1st bar is lower than the lateral line regardless of the color
      (Bid<PricePrH2_1b && Bid>PricePrH2_1b+50*Point))  // or if the market price is lower than the lateral line
     {//condition for opening
      // if the previous conditions are met, a CF pattern going upwards has emerged.
      patternSell= true; // pattern for opening a Sell position has emerged
      patternBuy = false;  // zeroing out the Buy pattern
// ------------------------------------------------------------------+
     // Set StopLoss as the Min value of the price over the interval from "0" to the bar of the 3rd fractal.
     SL_S=(High[iHighest(Symbol(),Period(),MODE_HIGH,VnfL3,0)]-Bid)/Point;
     if(SL_S<StopLevel) SL_S=StopLevel+12; // if SL_B is less than StopLevel
     // -------------------------------------------------------------+
     // set the TakeProfit value == 300 pip since the SELL order will be 
     // traced by shifting StopLoss along the upper fractals of the downtrend.
     TP_S=300;
// ==================================================================+
   if(OrdersTotal()<2) // we place one (or 2..3..etc.) orders  
    {  //open a position
     // -------------------------------------------------------------+  
     Print("  OP_SELL Chuvashov's Fork"," ; SL_S= ",SL_S," ; TP_S= ",TP_S);
     Op_Sell_Ch();
// ------------------------------------------------------------------+
//   draw lines and marks having deleted the existing ones         +
// ------------------------------------------------------------------+
     DelLineH(); CreateLineH(); CreateArrowH();
// ------------------------------------------------------------------+
     return;
       }//-open a position
      }//-condition for opening
     }//-Ma144   -if the 2nd condition is met:
    }//-price range
   }//-patternSell
  }//-condition regarding the direction of the trend lines is met.
 }//-Vol-at the first tick
//+=======================================================================+
//                   proceed to TRACING opened positions            +
//+=======================================================================+
for (i=OrdersTotal()-1; i>=0; i--)        // loop for selection of BUY orders 
   {//loop for selection of positions Buy
  if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {Print("Order selection error = ", GetLastError()); }
   if(OrderType()==OP_BUY )                // if the Buy order is placed
    { //2-type_Buy
//+=======================================================================+
//|  Conditions for closing BUY positions                                     +
//+=======================================================================+
   if(patternSell==true)         //  a pattern for opening a Sell position emerged
    { 
    Print(" closing the BUY position as the opposite pattern has emerged");
    Close_B_Ch();         // close the position SELL
    return; 
    }
//+=======================================================================+
//   Conditions for Modification of BUY positions                                      +
// ========================================================= 1st stage ===+
// ---- 1st stage ------------------------------------------ 1st stage ---+
    // The first modification stage: when the price reaches the profit 
    // equal to the StopLoss value, we move SL_B by 1/2 value of StopLoss
    // i.e. closer to the position opening level. (+StopLevel)
   if((Bid-OrderOpenPrice())>SL_B*Point      // if the difference between the price and the opening value is >SL_B
       && OrderStopLoss()<OrderOpenPrice())  // and if StopLoss is lower than the position opening level
    {// modif-1
     OrderModify(OrderTicket(),                // order #. 
     OrderOpenPrice(),                         // opening price. 
     OrderStopLoss()+(SL_B/2)*Point,           // New value of StopLoss.
     OrderTakeProfit()+1*Point,                // New value of TakeProfit.
     0,                                        // Deferred order expiration time.
     Red);                                     // Color of modification marks (dashes).
     return;
    }//-modif-1
// --- end of 1st stage -----------------------------------------------------+
// ---- 2nd stage ------------------------------------------ 2nd stage ---+
    // The second modification stage: when the price repeatedly reaches profit 
    // equal to the StopLoss value, we move SL_B to the 
    // zero-loss level, i.e. to the position opening level(+StopLevel). 
   if((Bid-OrderOpenPrice())>SL_B*Point      // if the difference between the price and the position opening value is >SL_B
       && OrderStopLoss()<OrderOpenPrice())  // and if StopLoss is lower than the position opening level
    {// modif-1
     OrderModify(OrderTicket(),                // order #. 
     OrderOpenPrice(),                         // opening price. 
     OrderStopLoss()+(SL_B+StopLevel)*Point,   // New value of StopLoss. 
     OrderTakeProfit()+1*Point,                // New value of TakeProfit.
     0,                                        // Deferred order expiration time.
     Magenta);                                 // Color of modification marks (dashes).
     return;
    }//-modif-1
// --- end of 2nd stage -----------------------------------------------------+
// ---- 3rd stage --------------------------------------- 3rd stage ------+
   //  When the price reaches the profit of more than 1.5 times the StopLoss value
   //  draw SL_B to the nearest lower fractal that should be higher than the preceding StopLoss
   if((Bid-OrderOpenPrice())>=(SL_B+SL_B/2)*Point  // if the difference between the price and the opening value is >SL_B+SL_B/2
       && OrderStopLoss()>=OrderOpenPrice()) // and if StopLoss is already at the zero-loss level. 
    {// modif2
     // move SL_B to the level of the nearest lower fractal,
     // for this purpose, we will find the nearest lower fractal:
    for (k=3;k<=24;k++)
     {//loop-
     if(Low[k]<Low[k+1] && Low[k]<Low[k+2] && Low[k]<Low[k-1] && Low[k]<Low[k-2])
      { // fractal Low
      VlFl_L=Low[k];           // Min value of the nearest fractal
     if(VlFl_L>OrderStopLoss()) // fractal that should be higher than the preceding StopLoss
      {// fractal is higher than SL_B
      tim1_L=iTime(NULL,0,k);  // Time of this fractal
      // shift StopLoss to the level of the Min value of the formed lower fractal 
      OrderModify(OrderTicket(),            // order # 
      OrderOpenPrice(),                     // opening price 
      VlFl_L+2*Point,                       // New value of StopLoss. // in zero-loss
      OrderTakeProfit()+1*Point,            // New value of TakeProfit.
      0,                                    // Deferred order expiration time.
      Aqua);                                // Color of StopLoss and/or TakeProfit modification arrows
      if(VlFl_L!=0)  break;                 // if the fractal is found, exit the loop
      return;
// --- end of 3rd stage ------------------------------------------------------+
      }//-fractal is higher than SL_B
     }//- fractal Low
    }//-loop-
   }//-modif2
  }//-2-type Buy
 }//-loop for selection of Buy positions
//+=======================================================================+
//                 SELL POSITION TRACING:                             +
//+=======================================================================+
  for (i=OrdersTotal()-1; i>=0; i--)        // loop for selection of SELL orders 
   {//loop for selection of positions Sell
  if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {Print("Order selection error = ", GetLastError()); }
   if(OrderType()==OP_SELL )                // if the Sell order is placed
    { //2-type_Sell
//+=======================================================================+
//|  Conditions for closing SELL positions                                    +
//+=======================================================================+
   if(patternBuy==true) // &&  // a pattern for opening a BUY position emerged
 ///     Low[1]>PricePrL1_1b)
    { 
    Print(" closing the SELL position as the opposite pattern has emerged");
    Close_S_Ch();         // close the position SELL 
    return;
    }
//+=======================================================================+
//   Conditions for Modification of SELL positions                                    +
// === 1st stage =========================================== 1st stage ===+
   // The first modification stage: when the price reaches the profit 
   // equal to the StopLoss value, we move SL_S by 2/3 value of SL_S  
   // closer to the zero-loss level, i.e. to the position opening level(+StopLevel). 
   if((OrderOpenPrice()-Bid)>SL_S*Point      // if the difference between the price and the position opening value is >SL_S
       && OrderStopLoss()>OrderOpenPrice())  // and if StopLoss is higher than the position opening level
   if(MdL==0)                                // 1st stage modification counter
    {//md1
     {// modif-1
     OrderModify(OrderTicket(),                // order #. 
     OrderOpenPrice(),                         // opening price. 
     OrderStopLoss()-(SL_S/3*2)*Point,         // New value of StopLoss.
     OrderTakeProfit()-2*Point,                // New value of TakeProfit.
     0,                                        // Deferred order expiration time.
     Aqua);                                    // Color of modification marks (dashes).
     MdL++;
     return;
     }//-modif-1
    }//-md1
  // --- end of 1st stage --------------------------------------------------+ 
  // ---- 2nd stage ------------------------------------------------------+
   if((OrderOpenPrice()-Bid)>SL_S*Point      // if the difference between the price and the position opening value is >SL_S
       && OrderStopLoss()>OrderOpenPrice())  // and if StopLoss is higher than the position opening level
   if(MdL>=1)
    {//md2
     {// modif-2
     OrderModify(OrderTicket(),                // order #. 
     OrderOpenPrice(),                         // opening price. 
     OrderStopLoss()-(SL_S+StopLevel)*Point,   // New value of StopLoss - at the zero-loss level
     OrderTakeProfit()-2*Point,                // New value of TakeProfit.
     0,                                        // Deferred order expiration time.
     Aqua);                                    // Color of modification marks (dashes).
     MdL++;
    return(0);
     }//-modif-2
    }//-md2
  // --- end of 2nd stage -------------------------------------------------+ 
  // --- 3rd stage -------------------------------------------------------+
   // When the price reaches the profit of more than 1.5 times the StopLoss value
   // draw SL_B to the nearest lower fractal that should be lower than the preceding StopLoss
   if((OrderOpenPrice()-Bid)>=(SL_B+SL_B/2)*Point  // if the difference between the price and the position opening value is>SL_B+SL_B/2
       && OrderStopLoss()<=OrderOpenPrice()) // and if StopLoss is already at the zero-loss level. 
    {//fractal Low  
     // move SL_B to the level of the nearest lower fractal.(for long time frames!)
     // for this purpose, we will find the nearest lower fractal:
    for (k=3;k<=12;k++)
     {//loop-
     if(High[k]>High[k+1] && High[k]>High[k+2] && High[k]>High[k-1] && High[k]>High[k-2])
      {//fractal High
      VlFl_H=High[k];           // Min value of the nearest fractal
    if(VlFl_H<OrderStopLoss())  // fractal that should be lower than the preceding StopLoss
      {//fractal is higher than SL_S
      timL1_H=iTime(NULL,0,k);  // Time of this fractal
  // ---------------------------------------------------------------------+ 
  // shift StopLoss to the upper fractal Max value level 
  // ---------------------------------------------------------------------+
     // Print(" before ==   Modif-3 we had "," == SL_S = ",OrderStopLoss()," ; TP_S = ",OrderTakeProfit());
     OrderModify(OrderTicket(),            // order # 
     OrderOpenPrice(),                     // opening price 
     VlFl_H,                               // New value of StopLoss. // in zero-loss
     OrderTakeProfit()-2*Point,            // New value of TakeProfit.
     0,                                    // Deferred order expiration time.
     Aqua);                                // Color of StopLoss and/or TakeProfit modification arrows
     return;
     // Print(" after = Modif-3 we have "," == SL_S = ",VlFl_H," ; TP_S = ",OrderTakeProfit()+SL_S*Point);
   if(VlFl_H!=0)  break;      // if the fractal is found, exit the loop
     }//-fractal is higher than SL_S
    }//-fractal High
   }//-loop- 
  }//-fractal Low
  // --- end of 3rd stage -------------------------------------------------+ 
  }//-2-type_Sell
 }//-loop for selection of positions Sell
//+=======================================================================+
   return(0);
  }//-start
// --- end ---